/*
 * duty_cycling.h
 *
 *  Created on: 24/05/2015
 *      Author: Erick Castillo
 */

#ifndef DUTY_CYCLING_H_
#define DUTY_CYCLING_H_

#include "app_config.h"
#include <time.h>


/******************************************************************************
 *  Global Definitions
 *****************************************************************************/
#define PARAM_MIN_DC		(float_t)APP_MIN_DC/100		// Node's minimum duty cycle
#define PARAM_MAX_DC		(float_t)APP_MAX_DC/100		// Node's maximum duty cycle
#define PARAM_STEP_SIZE		0.001
#define PARAM_SMOOTHING		0.0005						// Alpha parameter (1~few data points, 0~long history)
#define PARAM_VARIANCE		0.5							// Beta parameter

#define INIT_dc				(float_t)APP_INIT_DC/100	// Initial duty cycle
#define INIT_B				INIT_BATTERY_LEVEL			// Initial battery level
#define INIT_B_tgt			0.65						// Target battery level
#define INIT_Pvec_0			2
#define INIT_Pvec_1			-1
#define INIT_Pvec_2			1
#define INIT_Fvec_0			INIT_B
#define INIT_Fvec_1			INIT_dc
#define INIT_Fvec_2			-INIT_B_tgt


/******************************************************************************
 *  Global Function Declarations
 *****************************************************************************/
uint8_t DUTY_CYCLING_GetDC(float_t bat_level);


#endif /* DUTY_CYCLING_H_ */
