/*
 * energy_harvesting.h
 *
 *  Created on: 06/06/2015
 *      Author: Erick Castillo
 */

#ifndef ENERGY_HARVESTING_H_
#define ENERGY_HARVESTING_H_

#include "app_config.h"


/******************************************************************************
 *  Global Definitions
 *****************************************************************************/
#define USE_TEST_VALUES			1				// Use for testing when node has no battery
#define NODE_ACTIVE_PC			45.7000			// Active power consumption in mW
#define NODE_SLEEP_PC	 		0.0076			// Sleep power consumption in mW
#define BATT_EFFECTIVE_ENERGY  	7948.8			// Effective energy (80%) in Joules
#define BATT_CHARGE_EFFICIENCY	0.66			// Typical charging efficiency in NiMH


/******************************************************************************
 *  Global Function Declarations
 *****************************************************************************/
float_t ENERGY_HARVESTING_getBatteryLevel(uint8_t duty_cycle);


#endif /* ENERGY_HARVESTING_H_ */
