/*
 * radio.h
 *
 *  Created on: 15/05/2015
 *      Author: Erick Castillo
 */

#ifndef RADIO_H_
#define RADIO_H_

#include <stdbool.h>
#include "radio-config-wds-gen.h"
#include "app_config.h"


/*****************************************************************************
 *  Global Definitions
 *****************************************************************************/
// Maximum packet length definition (FIFO size)
#define RADIO_MAX_PACKET_LENGTH     64u

// Location of the packet fields
#define APP_PKT_MATCH_LOC			0u
#define APP_PKT_LEN_LOC				1u
#define APP_PKT_SRCID_LOC			2u
#define APP_PKT_TYPE_LOC			3u
#define APP_PKT_DATA_LOC			4u


/*****************************************************************************
 *  Global Typedefs
 *****************************************************************************/
typedef struct
{
  const uint8_t  *Radio_ConfigurationArray;
        uint8_t   Radio_ChannelNumber;
        uint8_t   Radio_PacketLength;
        uint8_t   Radio_State_After_Power_Up;
        uint16_t  Radio_Delay_Cnt_After_Reset;
        uint8_t   Radio_Variable_Packet_State;
        uint8_t   Radio_CustomPayload[RADIO_MAX_PACKET_LENGTH];

} tRadioConfiguration;


/*****************************************************************************
 *  Global Variable Declarations
 *****************************************************************************/
extern bool    radioIrqReceived;


/*****************************************************************************
 *  Global Function Declarations
 *****************************************************************************/
void    EZRADIO_Init(void);
void 	EZRADIO_Shutdown(void);
void	EZRADIO_Restart(void);
bool 	EZRADIO_StartTx(uint8_t channel, radioPkt_data *data);
void    EZRADIO_StartRx(uint8_t channel, uint8_t pkt_length);
bool    EZRADIO_CheckReceived(radioPkt_data *data);
bool    EZRADIO_CheckTransmitted(void);
bool    EZRADIO_CheckCRCError(void);
void    EZRADIO_ResetTRxFifo(void);


#endif /* RADIO_H_ */
